<?php
require_once( "db.php" );

//require_once( "useSingleton.php" );
/**
 * Methods for database handling.
 */
class Logincodes extends Db  {

   
    const BCRYPT_COST = 14;
	
	public $username;
	public $password;
	public $role;
	public $exist;
	public $email;
	 
	 
	 public function __construct() {

   }
	 
	 
    

    /**
     * Gets given users password.
     *
     * @param $username The username to get the password of.
     * @return The password of the given user.
     */
    public function getUsersPassword($email) {
		$instance = parent::getInstance();	
       $MySQLiconn  = $instance->getConnection();
		
        $sql = 'SELECT password
                FROM   customerlogin
                WHERE  email = :email';

        $statement = $MySQLiconn->prepare($sql);
        $statement->bindValue(':email', $email);

        $statement->execute();
        $row = $statement->fetch(PDO::FETCH_ASSOC);
        $this->password = $row['password'];

     

        return $this->password;
		  parent::DisConnect( $MySQLiconn);
    }



public function getUsersPasswordAdmin($email) {
		$instance = parent::getInstance();	
       $MySQLiconn  = $instance->getConnection();
		
        $sql = 'SELECT password
                FROM   adminlogin
                WHERE  email = :email';

        $statement = $MySQLiconn->prepare($sql);
        $statement->bindValue(':email', $email);

        $statement->execute();
        $row = $statement->fetch(PDO::FETCH_ASSOC);
        $this->password = $row['password'];

     

        return $this->password;
		  parent::DisConnect( $MySQLiconn);
    }
 
	


	
	
	public function getUsersPassword2($email) {
		$instance = parent::getInstance();	
       $MySQLiconn  = $instance->getConnection();
		
        $sql = 'SELECT *
                FROM   customerlogin
                WHERE  email = :email';

        $statement = $MySQLiconn->prepare($sql);
        $statement->bindValue(':email', $email);

        $statement->execute();
		$row = $statement->fetch(PDO::FETCH_ASSOC);
	
	    $this->role = $row['role'];
 
      return $this->role;
        
      
		 parent::DisConnect( $MySQLiconn);
		
    }
	
	
	
	public function getUsersPassword2Admin($email) {
		$instance = parent::getInstance();	
       $MySQLiconn  = $instance->getConnection();
		
        $sql = 'SELECT *
                FROM   adminlogin
                WHERE  email = :email';

        $statement = $MySQLiconn->prepare($sql);
        $statement->bindValue(':email', $email);

        $statement->execute();
		$row = $statement->fetch(PDO::FETCH_ASSOC);
	
	    $this->role = $row['role'];
 
      return $this->role;
        
      
		 parent::DisConnect( $MySQLiconn);
		
    }
	
	

    /**
     * Creates a new user.
     *
     * @param $username The username to create.
     * @param $password The password of the user.
     */
    public function createLogin($email,$password,$role,$textcode) {
	   $instance = parent::getInstance();	
       $MySQLiconn  = $instance->getConnection();	
	   
	 try{
	 
       $sql = "INSERT INTO customerlogin (email,password,role,textcode)
                VALUES (:email, :password, :role, :textcode)";
					

       $options = array('cost' => self::BCRYPT_COST);
        $derivedPassword = password_hash($password, PASSWORD_BCRYPT, $options);
       // $derivedTexcode = md5(uniqid(rand())); 
        $statement = $MySQLiconn->prepare($sql);
	
        $statement->bindValue(':email',$email, PDO::PARAM_STR );
		
        $statement->bindValue(":password", $derivedPassword, PDO::PARAM_STR);
        $statement->bindValue(":role", $role,  PDO::PARAM_STR);
		$statement->bindValue(":textcode", $textcode , PDO::PARAM_STR);
		
        $statement->execute();
		
		
		parent::DisConnect( $MySQLiconn);
	  }

        catch(Exception $e){
			echo "oops! ".$e->getMessage(); 
			
			}   
    }
	
	
	

   public function createLoginAdmin($email,$password,$role,$textcode) {
	   $instance = parent::getInstance();	
       $MySQLiconn  = $instance->getConnection();	
	   
	 try{
	 
       $sql = "INSERT INTO adminlogin (email,password,role,textcode)
                VALUES (:email, :password, :role, :textcode)";
					

       $options = array('cost' => self::BCRYPT_COST);
        $derivedPassword = password_hash($password, PASSWORD_BCRYPT, $options);
       // $derivedTexcode = md5(uniqid(rand())); 
        $statement = $MySQLiconn->prepare($sql);
	
        $statement->bindValue(':email',$email, PDO::PARAM_STR );
		
        $statement->bindValue(":password", $derivedPassword, PDO::PARAM_STR);
        $statement->bindValue(":role", $role,  PDO::PARAM_STR);
		$statement->bindValue(":textcode", $textcode , PDO::PARAM_STR);
		
        $statement->execute();
		
		
		parent::DisConnect( $MySQLiconn);
	  }

        catch(Exception $e){
			echo "oops! ".$e->getMessage(); 
			
			}   
    }	
	
	
	
	
	public function countAll(){
	$instance = parent::getInstance();
		//$instance = new DBAccess();
       $MySQLiconn  = $instance->getConnection();	
 
   $sql = "SELECT * from customers";
				$statement = $MySQLiconn->prepare($sql);
    $statement->execute();
 
    $num = $statement->rowCount();
 
    return $num;
	parent::DisConnect( $MySQLiconn);
}




   public function getPassword(){
	   return $this->password ;
	   }
	   
	 public function getRole(){
	   return $this->role ;
	   }   
	
	 public function getEmail(){
	   return $this->email ;
	   }  
	
	
	 
		
	

   public function updateLoginDetails($email,$password) {
	   $instance = parent::getInstance();	
       $MySQLiconn  = $instance->getConnection();	
	   
	 try{
	 
    //   $sql = "INSERT INTO login (staffno,password,role,email,textcode,password2)
              //  VALUES (:staffno, :password, :role, :email, :textcode, :password2)";
			  
			  $sql = "UPDATE customerlogin SET password = :password WHERE email = :email";
					

       $options = array('cost' => self::BCRYPT_COST);
        $derivedPassword = password_hash($password, PASSWORD_BCRYPT, $options);
       // $derivedTexcode = md5(uniqid(rand())); 
        $statement = $MySQLiconn->prepare($sql);
	
        $statement->bindValue(':email',$email, PDO::PARAM_STR );
		
        $statement->bindValue(":password", $derivedPassword, PDO::PARAM_STR);
       
        $statement->execute();
		
		
		parent::DisConnect( $MySQLiconn);
	  }

        catch(Exception $e){
			echo "oops! ".$e->getMessage(); 
			
			}   
    }	
	

  public function updateLoginDetailsAdmin($email,$password) {
	   $instance = parent::getInstance();	
       $MySQLiconn  = $instance->getConnection();	
	   
	 try{
	 
    //   $sql = "INSERT INTO login (staffno,password,role,email,textcode,password2)
              //  VALUES (:staffno, :password, :role, :email, :textcode, :password2)";
			  
			  $sql = "UPDATE adminlogin SET password = :password WHERE email = :email";
					

       $options = array('cost' => self::BCRYPT_COST);
        $derivedPassword = password_hash($password, PASSWORD_BCRYPT, $options);
       // $derivedTexcode = md5(uniqid(rand())); 
        $statement = $MySQLiconn->prepare($sql);
	
        $statement->bindValue(':email',$email, PDO::PARAM_STR );
		
        $statement->bindValue(":password", $derivedPassword, PDO::PARAM_STR);
       
        $statement->execute();
		
		
		parent::DisConnect( $MySQLiconn);
	  }

        catch(Exception $e){
			echo "oops! ".$e->getMessage(); 
			
			}   
    }	
	
	
  	
	 public function getUsersPasswordEmail($email) {
		$instance = parent::getInstance();	
       $MySQLiconn  = $instance->getConnection();
		
        $sql = 'SELECT *
                FROM   customerlogin
                WHERE  email = :email';

        $statement = $MySQLiconn->prepare($sql);
        $statement->bindValue(':email', $email);

        $statement->execute();
        $row = $statement->fetch(PDO::FETCH_ASSOC);
        $this->password = $row['password'];
        $this->email = $row['email'];
     

        return $this->password;
		  parent::DisConnect( $MySQLiconn);
    }
	
	
	
}